From 8e655ba7398c807b8bd979fc1851a5e0bd6f060e Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Thu, 26 Mar 2020 15:42:27 +0800
Subject: [PATCH 091/124] ath11k: enable idle power save mode

Host sends wmi command to allow hardware enter idle power
save mode in ath11k_mac_op_start function.

Add MISC_CAPS_IDLE_PS_SUPP to indicate whether idle power
save is supported.

Tested-on: QCA6390 WLAN.HST.1.0.1-01230-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: I4831f19e3dd9751309ecb708994e120f0c0045ca
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/core.c | 3 ++-
 drivers/net/wireless/ath/ath11k/hw.h   | 1 +
 drivers/net/wireless/ath/ath11k/mac.c  | 9 +++++++++
 3 files changed, 12 insertions(+), 1 deletion(-)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index e8e9f0b..dbbc690 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -46,7 +46,8 @@ static const struct ath11k_hw_params ath11k_hw_params_list[] = {
 		.single_pdev_only = true,
 		.hw_ops = &ath11k_hw_ops_qca6x90,
 		.misc_caps = MISC_CAPS_HOST2FW_RXBUF_RING |
-			     MISC_CAPS_TCL_0_ONLY,
+			     MISC_CAPS_TCL_0_ONLY |
+			     MISC_CAPS_IDLE_PS_SUPP,
 		.rxdma1_enable = false,
 		.num_rxmda_per_pdev = 2,
 		.vdev_start_delay = true,
diff --git a/drivers/net/wireless/ath/ath11k/hw.h b/drivers/net/wireless/ath/ath11k/hw.h
index 95dd62d..d757b37 100644
--- a/drivers/net/wireless/ath/ath11k/hw.h
+++ b/drivers/net/wireless/ath/ath11k/hw.h
@@ -84,6 +84,7 @@
 #define MISC_CAPS_HOST2FW_RXBUF_RING    BIT(1)
 #define MISC_CAPS_V2_MAP                BIT(2)
 #define MISC_CAPS_TCL_0_ONLY            BIT(3)
+#define MISC_CAPS_IDLE_PS_SUPP          BIT(4)
 
 enum ath11k_hw_rate_cck {
 	ATH11K_HW_RATE_CCK_LP_11M = 0,
diff --git a/drivers/net/wireless/ath/ath11k/mac.c b/drivers/net/wireless/ath/ath11k/mac.c
index 7d566a7..c64b711 100644
--- a/drivers/net/wireless/ath/ath11k/mac.c
+++ b/drivers/net/wireless/ath/ath11k/mac.c
@@ -4142,6 +4142,15 @@ static int ath11k_mac_op_start(struct ieee80211_hw *hw)
 	rcu_assign_pointer(ab->pdevs_active[ar->pdev_idx],
 			   &ab->pdevs[ar->pdev_idx]);
 
+	/* allow device to enter IMPS */
+	if (ar->ab->hw_params.misc_caps & MISC_CAPS_IDLE_PS_SUPP) {
+		ret = ath11k_wmi_pdev_set_param(ar, WMI_PDEV_PARAM_IDLE_PS_CONFIG,
+					        1, pdev->pdev_id);
+		if (ret) {
+			ath11k_err(ar->ab, "failed to enable idle ps: %d\n", ret);
+			goto err;
+		}
+	}
 	return 0;
 
 err:
-- 
2.7.4

